! D. R. Hamann
! Department of Physics and Astronomy, Rutgers University
! 2/22/2009
! drhamann@mat-simresearch.com

program ompi_abinit_test

 use mpi
 implicit none
 integer, parameter :: fnlen=264     ! maximum length of file name variables
 character(len=1), parameter :: ch10 = char(10)

 integer :: ierr, rank, size
 character(len=fnlen) :: filnam(5)

 call MPI_INIT(ierr)
 call MPI_COMM_RANK(MPI_COMM_WORLD, rank, ierr)
 call MPI_COMM_SIZE(MPI_COMM_WORLD, size, ierr)

! Print greetings for interactive user
 if(rank==0) then
  write(06,*)' ABINIT '
  write(06,*)' '

! When the following two lines (from iofn1.F90) are uncommented, 
!  my problem goes away.
! I notice that this is an option based on setting "READ_FROM_FILE"
!  for the cpp preprocessor.
! It looks like I can activate this with enable_stdin="no" for abinit
!  configure.

! close(5)
! open (unit=5,file='telast_2.files',form='formatted',status='old')

! Read name of input file (05):
  write(06,*)' Give name for formatted input file: '
  read(05, '(a)' ) filnam(1)
  write(06, '(a)' ) trim(filnam(1))
  write(06,*)' Give name for formatted output file:'
  read (05, '(a)' ) filnam(2)
  write (06, '(a)' ) trim(filnam(2))
  write(06,*)' Give root name for generic input files:'
  read (05, '(a)' ) filnam(3)
  write (06, '(a)' ) trim(filnam(3))
  write(06,*)' Give root name for generic output files:'
  read (05, '(a)' ) filnam(4)
  write (06, '(a)' ) trim(filnam(4))
  write(06,*)' Give root name for generic temporary files:'
  read (05, '(a)' ) filnam(5)
  write (06, '(a,a)' ) trim(filnam(5)),ch10
 end if

 call MPI_BCAST(filnam(1:5),5*fnlen,MPI_CHARACTER,0,&
&  MPI_COMM_WORLD,ierr)
 
 write(6, '(a,i4,a,i4,a,a,a,a,a,a,a,a,a,a,a,a,a,a)' )&
&  'Rank ',rank,' of',size,' reporting filenames',ch10,&
&  '  - input  file    -> ',trim(filnam(1)),ch10,&
&  '  - output file    -> ',trim(filnam(2)),ch10,&
&  '  - root for input  files -> ',trim(filnam(3)),ch10,&
&  '  - root for output files -> ',trim(filnam(4)),ch10

 call MPI_FINALIZE(ierr)

end program ompi_abinit_test
